
# Loading iris dataset
data(iris)

# Loading mtcars dataset
data(mtcars)

#This shows us the correlations between pairs, which may help us identify clusters.
pairs(mtcars[,1:4], main = "mtcars data")


##Distance matrix

x <- mtcars["Honda Civic",] #ext
y <- mtcars["Camaro Z28",] 
dist(rbind(x, y)) 


#repeating
z <- mtcars["Pontiac Firebird",] 
dist(rbind(y, z)) 

#distance for full set
d <- dist(as.matrix(mtcars))


# prepare hierarchical cluster
hc = hclust(d)

# very simple dendrogram
plot(hc, hang=-1) #hang places the labels all at the same level

##Example 2: `iris` dataset

head(iris)

#column names
colnames(iris)

#simple scatter plot
plot(iris$Petal.Length, iris$Petal.Width, main="Iris Data")

#giving each type a different shape
plot(iris$Petal.Length, iris$Petal.Width, pch=c(22,23,24)[unclass(iris$Species)], main="Iris Data")

#giving each type a colour
plot(iris$Petal.Length, iris$Petal.Width, pch=21, bg=c("red","green3","blue")[unclass(iris$Species)], 
main="Iris Data")

#correlations between pairs
pairs(iris[1:4], main = "Iris Data", pch = 21, bg = c("red", "green3", "blue")[unclass(iris$Species)])

##Distance matrix

d1 <- dist(as.matrix(iris))

#sampling 40 points
sampleiris <- iris[sample(1:150, 40),]

#calculating our distance matrix
distance <- dist(sampleiris[,-5])

#preparing the hierarchical cluster
cluster <- hclust(distance)

#plotting our dendrogram, with hang=-1 to have all labels at same level
plot(cluster, hang=-1, label=sampleiris$Species)

##Example 1: `iris` dataset


#we assign the data from column 1-4 (features) to variable $x$, 
#and the class (species) to variable $y$.

x = iris[,-5]
y = iris$Species


#kmeans algorithm
kc <- kmeans(x,3)
kc


#checking the accuracy
table(y,kc$cluster)

#plotting clusters
plot(x[c("Sepal.Length", "Sepal.Width")], col=kc$cluster)
points(kc$centers[,c("Sepal.Length", "Sepal.Width")], col=1:3, pch=23, cex=3)
